% $Id: NewEBayTest.oz,v 1.2 2010/04/15 20:36:03 leavens Exp $
\insert 'NewEBay.oz'
\insert 'TestingNoStop.oz'
declare
{StartTesting 'NewEBayTest $Revision$'}
MyEBay = {NewEBay}
local Status1 Status2 Status3 Status4 in
   {Send MyEBay bid(8 palin Status1)}
   {Send MyEBay bid(17 mccain Status2)}
   {Send MyEBay bid(27 bush Status3)}
   {Send MyEBay bid(24 romney Status4)}
   % losing bids should not yet be determined
   {Test {IsDet Status1} '==' false}
   {Send MyEBay finish}
   {Test Status1 '==' false}
   {Test Status2 '==' false}
   {Test Status3 '==' true}
   {Test Status4 '==' false}
   {Test {Send MyEBay whoWon($)} '==' bush}
end
MyEBay2 = {NewEBay}
local Status1 Status2 Status3 Status4
   Status5 Status6 Status7
in
   {Send MyEBay2 bid(100 agent007 Status1)}
   {Send MyEBay2 bid(15 agent86 Status2)}
   {Send MyEBay2 bid(99 agent99 Status3)}
   {Send MyEBay2 bid(99 agent992 Status4)}
   {Send MyEBay2 bid(100 agent1002 Status5)}
   {Send MyEBay2 bid(100 agent1003 Status6)}
   {Send MyEBay2 bid(100 agent1004 Status7)}
   {Send MyEBay2 finish}
   {StartTesting 'first of the highest bids wins'}
   {Test Status1 '==' true}
   {Test Status2 '==' false}
   {Test Status3 '==' false}
   {Test Status4 '==' false}
   {Test Status5 '==' false}
   {Test Status6 '==' false}
   {Test Status7 '==' false}
   {Test {Send MyEBay2 whoWon($)} '==' agent007}
end
{StartTesting done}
{StartTesting 'finishing with no bids'}
MyEBay3 = {NewEBay}
{Send MyEBay3 finish}
{Test {Send MyEBay3 whoWon($)} '==' none}
{StartTesting 'bidding after an auction is over loses'}
{Test {Send MyEBay3 bid(50 mad_hatter $)} '==' false}
{Test {Send MyEBay bid(999 alice $)} '==' false}
{StartTesting done}
